var OPTION_SPEC = -999;
var OPTION_ANY  = -1;
var OPTION_NONE =  0;
var OPTION_VALUES = Array();
var LICENCE_BAND_OPTION_VALUES = Array();

var READ_ONLY = "Read Only";
var DESKTOP = "Desktop";

LICENCE_BAND_OPTION_VALUES[ 0 ] = READ_ONLY;
LICENCE_BAND_OPTION_VALUES[ 1 ] = DESKTOP;

OPTION_VALUES[ 0 ] = OPTION_SPEC;
OPTION_VALUES[ 1 ] = OPTION_ANY;
OPTION_VALUES[ 2 ] = OPTION_NONE;

var oldlicenceText = "";
var selectedOption = OPTION_ANY;
var selectedLicenseBand = READ_ONLY;


function licenceText()
{
	if ( selectedOption == OPTION_SPEC )
	{
  	return processOptionSpecified( document.userProfile.userLicencesText.value )
	}
}

/**
* If authentication type is any other than server validated, remove the 
* read-write and desktop licence options
*/
function authenticationTypeChanged()
{
	var selectedUsertypeIndex = document.userProfile.usertype.selectedIndex;
	var desktopLicencebandOption = document.userProfile.licenceband.options[1];

	// User has no password or local password
	if ( selectedUsertypeIndex ==  0 || selectedUsertypeIndex == 1) {

		if(!desktopLicencebandOption.disabled) {

			desktopLicencebandOption.disabled= true;

		}
	}else {
		if(desktopLicencebandOption.disabled) {

			desktopLicencebandOption.disabled= false;
		}
	}
}
/**
* Check Desktop license band is not assigned to a local user before 
* adding or modifying a user
*/
function isLicencebandOK() {

	var selectedUsertypeIndex = document.userProfile.usertype.selectedIndex;
	var selectedLicenceband = document.userProfile.licenceband.selectedIndex;

	if ( selectedLicenceband == 1 && (selectedUsertypeIndex == 0 || selectedUsertypeIndex == 1) ) {

		alert("'Desktop' license band cannot be assigned to a local user.");
		return false;
	}

	return true;
}


//***************************************************
function licenceBandSelect(selectDefaults)
{
	var ael_user_properties_allow_filter_builder_access = document.forms["userProfile"].elements["ael_user_properties_allow_filter_builder_access"];
	var ael_user_properties_allow_view_builder_access = document.forms["userProfile"].elements["ael_user_properties_allow_view_builder_access"];
	var ael_user_properties_show_preferences = document.forms["userProfile"].elements["ael_user_properties_show_preferences"];
	var ael_user_properties_allow_custom_refresh = document.forms["userProfile"].elements["ael_user_properties_allow_custom_refresh"];
	var ael_user_properties_refresh_time = document.forms["userProfile"].elements["ael_user_properties_refresh_time"];
 	var ael_user_properties_minimum_refresh_time = document.forms["userProfile"].elements["ael_user_properties_minimum_refresh_time"];
 	var ael_user_properties_allow_select = document.forms["userProfile"].elements["ael_user_properties_allow_select"];
	var ael_user_properties_show_info = document.forms["userProfile"].elements["ael_user_properties_show_info"];
	var ael_user_properties_show_details = document.forms["userProfile"].elements["ael_user_properties_show_details"];
	var ael_user_properties_show_journal = document.forms["userProfile"].elements["ael_user_properties_show_journal"];
	var ael_user_properties_allow_journal_edit = document.forms["userProfile"].elements["ael_user_properties_allow_journal_edit"];

  selectedLicenseBand = LICENCE_BAND_OPTION_VALUES[ document.userProfile.licenceband.selectedIndex ];
	
	if (selectDefaults == "true")
	{
	   if ( selectedLicenseBand == READ_ONLY )
		 {
			ael_user_properties_allow_filter_builder_access.checked=false;
			ael_user_properties_allow_view_builder_access.checked=false;
			ael_user_properties_show_preferences.checked=false;
			ael_user_properties_allow_custom_refresh.checked=false;
			ael_user_properties_allow_select.checked=false;
			ael_user_properties_show_info.checked=false;
			ael_user_properties_show_details.checked=false;
			ael_user_properties_show_journal.checked=false;
			ael_user_properties_allow_journal_edit.checked=false;
	   }
	   else
   	 {
			ael_user_properties_allow_filter_builder_access.checked=true;
			ael_user_properties_allow_view_builder_access.checked=true;
			ael_user_properties_show_preferences.checked=true;
			ael_user_properties_allow_custom_refresh.checked=true;
			ael_user_properties_allow_select.checked=true;
			ael_user_properties_show_info.checked=true;
			ael_user_properties_show_details.checked=true;
			ael_user_properties_show_journal.checked=true;
			ael_user_properties_allow_journal_edit.checked=true;
   	}
	}

	setPreferenceOptions();
}

//***************************************************
function licenceSelect()
{
   selectedOption = getSelectedLicenceOption( );
   if ( isValidNumber( document.userProfile.userLicencesText.value ) )
   { 
      oldlicenceText = document.userProfile.userLicencesText.value;
   }
   if ( ( selectedOption == OPTION_NONE ) || ( selectedOption == OPTION_ANY ) )
   {
      document.userProfile.userLicencesText.value = "";
   }
   else
   {
      document.userProfile.userLicencesText.value = oldlicenceText;
   }
}

function processOptionSpecified( newValue )
{
   if ( isValidNumber( newValue ) )
   {
      oldlicenceText = newValue;  
   }
}

function isSpaceString( testString )
{
   if ( testString == "" ) 
   {
      return false;
   }
   for ( var i = 0; i < testString.length ; i++ )
   {
      if ( testString.charAt( i ) != " " ) 
      {
         return false;
      }
   }
   return true;
}

function getSelectedLicenceOption( )
{
   return  OPTION_VALUES[ document.userProfile.licencetype.selectedIndex ];
}

function isValidNumber( newValue )
{
   return ( newValue != "" && !isSpaceString( newValue ) && !isNaN( newValue ) && newValue > 0 )
}

function setPreferenceOptions()
{
	var ael_user_properties_allow_filter_builder_access = document.forms["userProfile"].elements["ael_user_properties_allow_filter_builder_access"];
	var ael_user_properties_allow_view_builder_access = document.forms["userProfile"].elements["ael_user_properties_allow_view_builder_access"];
	var ael_user_properties_show_preferences = document.forms["userProfile"].elements["ael_user_properties_show_preferences"];
	var ael_user_properties_allow_custom_refresh = document.forms["userProfile"].elements["ael_user_properties_allow_custom_refresh"];
	var ael_user_properties_refresh_time = document.forms["userProfile"].elements["ael_user_properties_refresh_time"];
 	var ael_user_properties_minimum_refresh_time = document.forms["userProfile"].elements["ael_user_properties_minimum_refresh_time"];
 	var ael_user_properties_allow_select = document.forms["userProfile"].elements["ael_user_properties_allow_select"];
	var ael_user_properties_show_info = document.forms["userProfile"].elements["ael_user_properties_show_info"];
	var ael_user_properties_show_details = document.forms["userProfile"].elements["ael_user_properties_show_details"];
	var ael_user_properties_show_journal = document.forms["userProfile"].elements["ael_user_properties_show_journal"];
	var ael_user_properties_allow_journal_edit = document.forms["userProfile"].elements["ael_user_properties_allow_journal_edit"];

  selectedLicenseBand = LICENCE_BAND_OPTION_VALUES[ document.userProfile.licenceband.selectedIndex ];

   if ( selectedLicenseBand == READ_ONLY )
	 {
		ael_user_properties_allow_filter_builder_access.disabled=true;
		ael_user_properties_allow_view_builder_access.disabled=true;		
		ael_user_properties_show_preferences.disabled=true;
		ael_user_properties_allow_custom_refresh.disabled=true;
		ael_user_properties_refresh_time.disabled=true;
		ael_user_properties_allow_select.disabled=true;		
		ael_user_properties_show_info.disabled=true;
		ael_user_properties_show_details.disabled=true;
		ael_user_properties_show_journal.disabled=true;
		ael_user_properties_allow_journal_edit.disabled=true;		
   }
   else
   {
		ael_user_properties_allow_filter_builder_access.disabled=false;
		ael_user_properties_allow_view_builder_access.disabled=false;		
		ael_user_properties_show_preferences.disabled=false;
		ael_user_properties_allow_custom_refresh.disabled=false;
		ael_user_properties_refresh_time.disabled=false;
		ael_user_properties_allow_select.disabled=false;		
		ael_user_properties_show_info.disabled=false;
		ael_user_properties_show_details.disabled=false;
		ael_user_properties_show_journal.disabled=false;
		ael_user_properties_allow_journal_edit.disabled=false;		
   }

  var enabled = document.forms["userProfile"].elements["ael_user_properties_show_preferences"].checked;
  var allowCustomRefresh = document.forms["userProfile"].elements["ael_user_properties_allow_custom_refresh"];
  var minRefreshTime = document.forms["userProfile"].elements["ael_user_properties_minimum_refresh_time"];

  allowCustomRefresh.disabled = !enabled;
  minRefreshTime.disabled = !enabled;

  if (enabled == false)
  {
    allowCustomRefresh.checked = enabled;
  }

}

function setSelectOptions()
{
  var enabled = document.forms["userProfile"].elements["ael_user_properties_allow_select"].checked;
  var showInfo = document.forms["userProfile"].elements["ael_user_properties_show_info"];
  var showDetails = document.forms["userProfile"].elements["ael_user_properties_show_details"];
  var showJournal = document.forms["userProfile"].elements["ael_user_properties_show_journal"];
  var editJournal = document.forms["userProfile"].elements["ael_user_properties_allow_journal_edit"];

  showInfo.disabled = !enabled;
  showDetails.disabled = !enabled;
  showJournal.disabled = !enabled;
  editJournal.disabled = !enabled;

  if (enabled == false)
  {
    showInfo.checked = enabled;
    showDetails.checked = enabled;
    showJournal.checked = enabled;
  }
}

function init()
{
	try
  {
		licenceBandSelect("false");
  	setSelectOptions();
	  NCOWebtopInit();
	
		//NBS28224. Make sure desktop band is available where appropriate.
		authenticationTypeChanged();
		//////////////////////////////////////////////////////////////////
	}
	catch (er)
	{
//		alert(er);
	}
}
