
	//******************************************************
	function NCOWebtopEventListViewDisplayFields( fieldName , fieldNameJustify , columnTitle, columnTitleJustify , columnWidth )
	{
		this._fieldName = fieldName;
		this._fieldNameJustify = fieldNameJustify;
		this._columnTitle = columnTitle;
		this._columnTitleJustify = columnTitleJustify;
		this._columnWidth = columnWidth;
	}


	//******************************************************
	function setName( name )
	{
		this._name = name;
	}

	//******************************************************
	function getName()
	{
		return this._name;
	}
	
	//******************************************************
	function setEventListDisplayFieldsValues( fieldName , fieldNameJustify , columnTitle, columnTitleJustify , columnWidth )
	{
		this._fieldName.value = fieldName;
		this._fieldNameJustify.selectedIndex = fieldNameJustify;
		this._columnTitle.value = columnTitle;
		this._columnTitleJustify.selectedIndex = columnTitleJustify;
		this._columnWidth.value = columnWidth;	
	}

	//******************************************************	
	function setEventListDisplayColumnValue( columnWidth )
	{
		this._columnWidth.value = columnWidth;	
	}

	//******************************************************
	function getFieldNameValue()
	{
		return this._fieldName.value;
	}
		
	//******************************************************
	function getFieldNameJustifyValue()
	{
		return this._fieldNameJustify.selectedIndex;
	}
	
	//******************************************************
	function getColumnTitleValue()
	{
		return this._columnTitle.value;
	}
	
	//******************************************************
	function getColumnTitleJustifyValue()
	{
		return this._columnTitleJustify.selectedIndex;
	}
	
	//******************************************************
	function clearEventListDisplay()
	{
		this._fieldName.value = "";
		this._fieldNameJustify.selectedIndex = 0;
		this._columnTitle.value = "";
		this._columnTitleJustify.selectedIndex = 0;
		this._columnWidth.value = "";	
	}

	//******************************************************
	function getColumnWidthValue()
	{
			return this._columnWidth.value;
	}
	
	//******************************************************
	NCOWebtopEventListViewDisplayFields.prototype.setFieldValues = setEventListDisplayFieldsValues;
	NCOWebtopEventListViewDisplayFields.prototype.getFieldNameValue = getFieldNameValue;
	NCOWebtopEventListViewDisplayFields.prototype.getFieldNameJustifyValue  = getFieldNameJustifyValue ;
	NCOWebtopEventListViewDisplayFields.prototype.getColumnTitleValue  = getColumnTitleValue ;
	NCOWebtopEventListViewDisplayFields.prototype.getColumnTitleJustifyValue  = getColumnTitleJustifyValue ;
	NCOWebtopEventListViewDisplayFields.prototype.getColumnWidthValue  = getColumnWidthValue ;
	NCOWebtopEventListViewDisplayFields.prototype.getName  = getName ;
	NCOWebtopEventListViewDisplayFields.prototype.setName  = setName ;
	NCOWebtopEventListViewDisplayFields.prototype.clearDisplay  = clearEventListDisplay ;
	NCOWebtopEventListViewDisplayFields.prototype.setColumnWidthValue  =  setEventListDisplayColumnValue;
	


	//******************************************************
	function NCOWebtopSortedByDisplayFields( fieldNameElement , sortElement )
	{
		this._fieldName = fieldNameElement;
		this._sortElement = sortElement;
	}
	
	//******************************************************
	function sortedByToString()
	{
		var string = "NCOWebtopSortedByDisplayFields( this._fieldName=" + this._fieldName + ",this._sortElement=" + this._sortElement + ")";
		return string;
	}

	//******************************************************
	function setSortedByElementValues( fieldNameValue , sortValue )
	{
		this._fieldName.value = fieldNameValue;
		this._sortElement.selectedIndex = sortValue;
	}		
	
	//******************************************************
	function getSortValue()
	{
		return this._sortElement.selectedIndex;
	}

	//******************************************************
	function clearSortedByDisplay()	
	{
		this._fieldName.value = "";
		this._sortElement.selectedIndex = 0;
	}		
	
	NCOWebtopSortedByDisplayFields.prototype.setElementValues = setSortedByElementValues;
	NCOWebtopSortedByDisplayFields.prototype.getFieldNameValue = getFieldNameValue;
	NCOWebtopSortedByDisplayFields.prototype.getSortValue = getSortValue;
	NCOWebtopSortedByDisplayFields.prototype.getName = getName;
	NCOWebtopSortedByDisplayFields.prototype.setName = setName;
	NCOWebtopSortedByDisplayFields.prototype.clearDisplay = clearSortedByDisplay;
	

	function NCOWebtopFormElement( selectElement )
	{
		this._selectElement = selectElement;
		this._encodedElement = null;
		this._displayElements = null;
	}
	
	//******************************************************
	function getEncodedElement()
	{
		return this._encodedElement;
	}
	//******************************************************
	function setEncodedElement( encodedElement )
	{
		this._encodedElement = encodedElement;
	}
	
	//******************************************************
	function getDisplayElements()
	{
		return this._displayElements;
	}
	
	//******************************************************
	function setDisplayElements( displayElements )
	{
		this._displayElements = displayElements;
	}

	//******************************************************
	function setFormElementSelectOption( option , index )
	{
		this._selectElement.options[ index ] = option;		
	}


	//******************************************************
	function getOptionValue( index )
	{

		if ( index > ( this._selectElement.options.length - 1 ) )
		{
			return null;
		}
		else
		{
			return this._selectElement.options[ index ].value;
		}
	}

	//******************************************************
	function removeLastElement()
	{
		this._selectElement.options.length--;
	}

	//******************************************************
	function clearSelect()
	{
		this._selectElement.options.length = 0;
	}

	//******************************************************
	function getOptionCount()
	{
		return this._selectElement.options.length;
	}

	//******************************************************
	function getSelectedIndex()
	{
		return this._selectElement.selectedIndex;
	}

	//******************************************************
	function setSelectedIndex( index )
	{
		this._selectElement.selectedIndex = index;
	}

	//******************************************************
	function swapOptions( firstIndex , secondIndex )
	{
		var index = this._selectElement.selectedIndex;
		if ( index == firstIndex )
		{
			index = secondIndex;
		}
		else if ( index == secondIndex )
		{
			index = firstIndex;
		}
		var firstOption = this.cloneOption( firstIndex );
		var secondOption = this.cloneOption( secondIndex );
		this._selectElement[ firstIndex ] = secondOption;
		this._selectElement[ secondOption ] = firstOption;
		this._selectElement.selectedIndex = index;
	}

	//******************************************************
	function removeOption( index )
	{

	}

	//******************************************************
	function cloneOption( index )
	{		
		var text = this._selectElement[ index ].text;
		var value = this._selectElement[ index ].value;
		return new Option( text , value );
	}

	//******************************************************
	function clearAllData()
	{
		this.clearDisplayElement();
		this._selectElement.length = 0;
	}

	//******************************************************
	function clearDisplayElement()
	{
		if ( this._displayElements != null )
		{
			this._displayElements.clearDisplay();
		}
	}

	//******************************************************
	function getFormElementSelectOptionCount()
	{
		return 	this._selectElement.length;
	}


	NCOWebtopFormElement.prototype.clearSelect = clearSelect;
	NCOWebtopFormElement.prototype.getEncodedElement = getEncodedElement;
	NCOWebtopFormElement.prototype.setEncodedElement = setEncodedElement;
	NCOWebtopFormElement.prototype.setDisplayElements = setDisplayElements;
	NCOWebtopFormElement.prototype.getDisplayElements = getDisplayElements;
	NCOWebtopFormElement.prototype.getOptionValue = getOptionValue;
	NCOWebtopFormElement.prototype.setSelectOption = setFormElementSelectOption;
	NCOWebtopFormElement.prototype.getSelectedIndex = getSelectedIndex;
	NCOWebtopFormElement.prototype.setSelectedIndex = setSelectedIndex;
	NCOWebtopFormElement.prototype.cloneOption = cloneOption;
	NCOWebtopFormElement.prototype.clearDisplayElement = clearDisplayElement;
	NCOWebtopFormElement.prototype.toString = sortedByToString ;
	NCOWebtopFormElement.prototype.getName = getName ;
	NCOWebtopFormElement.prototype.setName = setName ;
	NCOWebtopFormElement.prototype.removeLastElement = removeLastElement;
	NCOWebtopFormElement.prototype.clearAllData = clearAllData;
	NCOWebtopFormElement.prototype.getOptionCount = getFormElementSelectOptionCount;

	//*******************************************************************************************************