<%@ page language="java" contentType="text/javascript" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>
<%@ taglib prefix="ncw-utils" uri="/WEB-INF/tld/ncw-utils.tld" %>
<jsp:useBean id="formbean" class="com.micromuse.wave.fvbuilder.Form" />
<jsp:setProperty name="formbean" property="*"/>

// Global list mappings
var NCWebtopFieldLists = new Array();
var NCWebtopComparatorLists = new Array(
    "",
    "=",
    "!=",
    ">=",
    ">",
    "<=",
    "<");

// Parser return error for these two, leave them for now
//,
//    "not in",
//    "in");

var NCWT_FIELD_TYPE = "fieldType";
var NCWT_FIELD_NAME = "fieldName" ;
var NCWT_DISPLAY_NAME = "displayName";

var F_INT = 0;
var F_LONG = 1;
var F_STRING=2;
var F_UINCR=6;
/******************************************************************************************
 *
 * Get an Array of the fields that can be used to generate metrics.
 */
function getMetricFields( objectServerName )
{
	var osFields = NCWebtopFieldLists[ objectServerName ];
	var metricFields = new Array();
	for ( var i = 0 ; i < osFields.length ; i++ )
	{
		if  ( 
			osFields[ i ][ NCWT_FIELD_TYPE ] == F_INT ||
			osFields[ i ][ NCWT_FIELD_TYPE ] == F_LONG ||			
			osFields[ i ][ NCWT_FIELD_TYPE ] == F_UINCR
		    )
		{
			metricFields[ metricFields.length++ ] = osFields[ i ][ NCWT_FIELD_NAME ];
		}
	}
	return metricFields;
}

/******************************************************************************************
 *
 */
function getCurrentObjectServer()
{	
	var index = document.forms[ "filterForm" ].elements[ "os"].selectedIndex;
	return  document.forms[ "filterForm" ].elements[ "os" ].options[ index ].value ;
}

/******************************************************************************************
 *
 */
function getCurrentOSFieldDetails()
{
	return NCWebtopFieldLists[ getCurrentObjectServer() ];
}

/******************************************************************************************
 *
 */
function getOSList()
{
	var osArray = new Array();
	var numOfObjectServers = "<c:out value="${pageScope.formbean.numOfObjectServers}"/>";
	var i = 0;

	<c:forEach var="osname" items="${pageScope.formbean.osnames}">
	i = 0;
	osArray[ "<c:out value="${osname}"/>" ] = new Array();

		<c:set target="${pageScope.formbean}" property="os" value="${osname}"/>
		<c:forEach var="osfield" items="${pageScope.formbean.osFieldDescs}">
		osArray[ "<c:out value="${osname}"/>" ][ i ] = new Array();
		osArray[ "<c:out value="${osname}"/>" ][ i ][ NCWT_FIELD_NAME ] = "<c:out value="${osfield.fieldName}"/>";
		osArray[ "<c:out value="${osname}"/>" ][ i ][ NCWT_DISPLAY_NAME ] = "<c:out value="${osfield.displayName}"/>";
		osArray[ "<c:out value="${osname}"/>" ][ i ][ NCWT_FIELD_TYPE ] = <c:out value="${osfield.fieldType}"/>;		
		i++;
		</c:forEach>
	</c:forEach>	
	return osArray;
}


/******************************************************************************************
 *
 */
function getDropDownFieldOptions()
{
	var fieldDetails = getCurrentOSFieldDetails();
	var totalLength = fieldDetails.length + 1;
	var options = new Array( );
	options[ 0 ] = getBlankOption();

	for ( var i = 1 ; i < totalLength ; i++ )
	{
		options[ i ] = document.createElement( "option" );
		options[ i ].text = fieldDetails[ i - 1 ][ NCWT_DISPLAY_NAME ];
		options[ i ].value = fieldDetails[ i - 1 ][ NCWT_FIELD_NAME ];

	}
	return options;

}


/******************************************************************************************
 *
 */
function getDropDownComparatorOptions(type)
{
	if(type == F_STRING) {

		var options = new Array( 9 );

		NCWebtopComparatorLists[ 7 ] = "not like";
		NCWebtopComparatorLists[ 8 ] = "like";
	}else {
		var options = new Array( 7 );

		//Parser return error for these two, leave them for now, otherwise, change above line to "var options = new Array( 9 );"
		//NCWebtopComparatorLists[ 7 ] = "not in";
		//NCWebtopComparatorLists[ 8 ] = "in";
	}

	for ( var i = 0 ; i < options.length ; i++ )
	{
		options[ i ] = document.createElement( "option" );
		options[ i ].text = NCWebtopComparatorLists[ i  ];
		options[ i ].value = NCWebtopComparatorLists[ i ];
	}
	return options;

}

/******************************************************************************************
 *
 */
function getBlankOption()
{
	var option = document.createElement( "option" );
	option.text = "";
	option.value = "";
	return option;
}

/******************************************************************************************
 *
 */
function updateComparatorValue(evnt)
{

  var eventSource = null;
  <ncw-utils:brcon browser="ns">  
  if ( evnt != null ) eventSource = evnt.currentTarget;
  else return;
  </ncw-utils:brcon>

  eventSource = getEventSource( evnt );
  var baseTableRow = getBaseTableRow( eventSource );
  var fieldCell = (baseTableRow.getElementsByTagName( "TD" ))[ 0 ];
  var field = (fieldCell.getElementsByTagName( "select" ))[ 0 ];
  var idx = field.selectedIndex;
  var fields = getCurrentOSFieldDetails();
  var value = fields[ idx-1 ][ NCWT_FIELD_NAME ];
  var type = fields[ idx-1 ][ NCWT_FIELD_TYPE ];

  var comparatorCell = (baseTableRow.getElementsByTagName( "TD" ))[ 1 ];
  var currentDropDowns = (comparatorCell.getElementsByTagName( "select" ))[0];
  var newDropDown = createComparatorElementSelect(type);
  comparatorCell.replaceChild( newDropDown , currentDropDowns);


}