<%@ page language="java" contentType="text/javacript" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>

/******************************************************************************************
 *
 */
function init()
{
	document.addMessage = addMessage;
	document.setMessage = setMessage;
}


/******************************************************************************************
 *
 */
function addMessage( messageString )
{
	var messageCell = document.getElementById( "messageCell" );
	alert("message string: "+ messageString);
	messageCell.appendChild( document.createTextNode( messageString ) );
}

/******************************************************************************************
 *
 */
function setMessage( messageString )
{
	clearMessages();
	addMessage( messageString );
}

/******************************************************************************************
 *
 */
function clearMessages()
{
	var messageCell = document.getElementById( "messageCell" );
	var length = messageCell.childNodes.length;
	for ( var i = 0 ; i < length ; i++ )
	{
		messageCell.removeChild( messageCell.childNodes[ 0 ] );
	}

}

/******************************************************************************************
 *
 */
function reloadFilterList(message) {

	if(window.parent.frames[ 'main'] == null) return;

	mainDoc = window.parent.frames[ 'main'].document.filterForm;
	listFrame = window.parent.frames[ 'sidebar' ].filterlist;

	if(mainDoc != null && listFrame != null) {

		if(message == "filter.updated") {

			if(listFrame != null) {
				listFrame.filterTypeChange();

	   		        var idx = listFrame.document.filterForm.filterlist.selectedIndex;

				if(idx != -1) {

					var filter = listFrame.document.filterForm.filterlist.options[idx].value;
				
					if (filter == null || filter.length==0)
					{
						filter = mainDoc.filtername.value;
					}
				}

				notifyAEL(filter);					
			}
			// Display welcome page in main frame after creating a filter
			oldaction = mainDoc.elements['oldaction'].value;
			if(oldaction == "Create" || oldaction == "Copy") {

				url = "/filterbuilder/welcome.jsp";
        			frame  = window.parent.frames[ 'main' ].name;

				window.open(url, frame);
  			}
  			// Close window if "Ok" button pressed
			var act = mainDoc.elements['operation'].value;
			if(act == "Ok") {				
					window.top.close();

			}
				
		}else if(message == "filter.deleted") {
				
			if(mainDoc != null && listFrame != null) {
				mainDoc.action = 'welcome.jsp';
				mainDoc.target = 'main';
				mainDoc.submit();

				// Reload filterlist
				listFrame.filterTypeChange();

				// Notify AEL
				notifyAEL("");
			}
		}else {
			// set the operation to init value
			mainDoc.elements['operation'].value = "";
		}
		
	}
}


/******************************************************************************************
 * Inform any AEL's that the filters have been modified.
 * Optional parameter can be used to specify that a specific filter has been
 * changed.
 */
function notifyAEL(filter) {

	var doc = document;

	//Brute force reload of ael filters
	doc.applets.ncw_ael_prompter.resyncFilters();
	
	if (filter!=null && filter.length >0)
	{
		//Tell the ael that this specific filter has changed.
		doc.applets.ncw_ael_prompter.filterUpdated(filter);
	}
		
	while (doc.applets.ncw_ael_prompter.isExecuting())
	{
		//Spinlock to prevent premature window closure. This stops the AEL prompter 
		//applet from being destroyed before it has finished AEL notification. Ugly.			
	}

}
